Solid Example: Expanding

import {
  columnFilteringFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  createTable,
  filterFn_between,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_text,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, Show, createEffect, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type { Column, Table } from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  columnFilteringFeature,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSortingFeature,
  rowSelectionFeature,
  expandedRowModel: createExpandedRowModel(),
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  sortedRowModel: createSortedRowModel(),
  filterFns: {
    between: filterFn_between,
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

function App() {
  const [data, setData] = createSignal(makeData(100, 5, 3))
  const refreshData = () => setData(makeData(100, 5, 3))
  const stressTest = () => setData(makeData(10_000, 5, 3))

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'rowNumber',
      header: '#',
      cell: ({ row }) => row.getDisplayIndex() + 1,
    }),
    columnHelper.accessor('firstName', {
      header: ({ table }) => (
        <>
          <IndeterminateCheckbox
            checked={table.getIsAllRowsSelected()}
            indeterminate={table.getIsSomeRowsSelected()}
            onChange={table.getToggleAllRowsSelectedHandler()}
          />{' '}
          <button onClick={table.getToggleAllRowsExpandedHandler()}>
            {table.getIsAllRowsExpanded() ? '👇' : '👉'}
          </button>{' '}
          First Name
        </>
      ),
      cell: ({ row, getValue }) => (
        <div style={{ 'padding-left': `${row.depth * 2}rem` }}>
          <div>
            <IndeterminateCheckbox
              checked={
                row.getIsSelected() ||
                (row.getCanSelectSubRows() && row.getIsAllSubRowsSelected())
              }
              indeterminate={row.getIsSomeSelected()}
              onClick={row.getToggleSelectedHandler({
                // selectChildren: false
              })}
            />{' '}
            {row.getCanExpand() ? (
              <button
                onClick={row.getToggleExpandedHandler()}
                style={{ cursor: 'pointer' }}
              >
                {row.getIsExpanded() ? '👇' : '👉'}
              </button>
            ) : (
              '🔵'
            )}{' '}
            {getValue<string>()}
          </div>
        </div>
      ),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      cell: (info) => info.getValue(),
      header: () => <span>Last Name</span>,
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
      filterFn: 'between',
    }),
    columnHelper.accessor('visits', {
      header: () => <span>Visits</span>,
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      footer: (props) => props.column.id,
    }),
  ])

  const table = createTable({
    features,
    columns,
    get data() {
      return data()
    },
    getSubRows: (row) => row.subRows, // tell the table where nested rows live
    // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
    // enableMultiRowSelection: false, // allow only one selected row at a time; default true
    // enableSubRowSelection: false, // disable sub-row selection; default true
    // enableRowRangeSelection: false, // disable shift-click range selection; default true
    // initialState: { expanded: { '0': true } }, // expand rows on first render
    // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
    // state: { expanded }, // classic controlled state; pair with onExpandedChange
    // onExpandedChange: setExpanded,
    // enableExpanding: false, // disable expanding for every row; default true
    // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
    // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
    // manualExpanding: true, // pass data that is already expanded, for example from a server
    // paginateExpandedRows: false, // keep expanded children on their parent page; default true
    // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
    // autoResetAll: false, // turn off every feature's automatic reset, including expansion
    // enableFilters: false, // disable all column and global filtering; default true
    // enableColumnFilters: false, // disable per-column filters; default true
    // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
    // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
    // manualFiltering: true, // pass data that is already filtered, for example from a server
    debugTable: true,
  })

  return (
    <div class="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (10k rows)</button>
      </div>
      <div class="spacer-sm" />
      <table>
        <thead>
          <For each={table.getHeaderGroups()}>
            {(headerGroup) => (
              <tr>
                <For each={headerGroup.headers}>
                  {(header) => (
                    <th colSpan={header.colSpan}>
                      <Show when={!header.isPlaceholder}>
                        <div>
                          <table.FlexRender header={header} />
                          <Show when={header.column.getCanFilter()}>
                            <div>
                              <Filter column={header.column} table={table} />
                            </div>
                          </Show>
                        </div>
                      </Show>
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </thead>
        <tbody>
          <For each={table.getRowModel().rows}>
            {(row) => (
              <tr>
                <For each={row.getAllCells()}>
                  {(cell) => (
                    <td>
                      <table.FlexRender cell={cell} />
                    </td>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tbody>
      </table>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.currentTarget.value))
          }}
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  const columnFilterValue = () => column.getFilterValue()

  return typeof firstValue === 'number' ? (
    <div class="filter-row">
      <input
        type="number"
        value={(columnFilterValue() as [number, number] | undefined)?.[0] ?? ''}
        onInput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            e.currentTarget.value,
            old?.[1],
          ])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={(columnFilterValue() as [number, number] | undefined)?.[1] ?? ''}
        onInput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            e.currentTarget.value,
          ])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  ) : (
    <input
      type="text"
      value={(columnFilterValue() ?? '') as string}
      onInput={(e) => column.setFilterValue(e.currentTarget.value)}
      placeholder="Search..."
      class="filter-select"
    />
  )
}

function IndeterminateCheckbox(props: {
  indeterminate?: boolean
  checked?: boolean
  className?: string
  onChange?: (event: Event) => void
  onClick?: (event: MouseEvent) => void
}) {
  let ref: HTMLInputElement | undefined

  createEffect(() => {
    if (typeof props.indeterminate === 'boolean' && ref) {
      ref.indeterminate = !props.checked && props.indeterminate
    }
  })

  return (
    <input
      type="checkbox"
      ref={ref}
      class={`${props.className ?? ''} sortable-header`}
      checked={props.checked}
      onChange={props.onChange}
      onClick={props.onClick}
    />
  )
}

export default App
import {
  columnFilteringFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  createTable,
  filterFn_between,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_text,
  tableFeatures,
} from '@tanstack/solid-table'
import { For, Show, createEffect, createSignal } from 'solid-js'
import { makeData } from './makeData'
import type { Column, Table } from '@tanstack/solid-table'
import type { Person } from './makeData'

const features = tableFeatures({
  columnFilteringFeature,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSortingFeature,
  rowSelectionFeature,
  expandedRowModel: createExpandedRowModel(),
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  sortedRowModel: createSortedRowModel(),
  filterFns: {
    between: filterFn_between,
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

function App() {
  const [data, setData] = createSignal(makeData(100, 5, 3))
  const refreshData = () => setData(makeData(100, 5, 3))
  const stressTest = () => setData(makeData(10_000, 5, 3))

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'rowNumber',
      header: '#',
      cell: ({ row }) => row.getDisplayIndex() + 1,
    }),
    columnHelper.accessor('firstName', {
      header: ({ table }) => (
        <>
          <IndeterminateCheckbox
            checked={table.getIsAllRowsSelected()}
            indeterminate={table.getIsSomeRowsSelected()}
            onChange={table.getToggleAllRowsSelectedHandler()}
          />{' '}
          <button onClick={table.getToggleAllRowsExpandedHandler()}>
            {table.getIsAllRowsExpanded() ? '👇' : '👉'}
          </button>{' '}
          First Name
        </>
      ),
      cell: ({ row, getValue }) => (
        <div style={{ 'padding-left': `${row.depth * 2}rem` }}>
          <div>
            <IndeterminateCheckbox
              checked={
                row.getIsSelected() ||
                (row.getCanSelectSubRows() && row.getIsAllSubRowsSelected())
              }
              indeterminate={row.getIsSomeSelected()}
              onClick={row.getToggleSelectedHandler({
                // selectChildren: false
              })}
            />{' '}
            {row.getCanExpand() ? (
              <button
                onClick={row.getToggleExpandedHandler()}
                style={{ cursor: 'pointer' }}
              >
                {row.getIsExpanded() ? '👇' : '👉'}
              </button>
            ) : (
              '🔵'
            )}{' '}
            {getValue<string>()}
          </div>
        </div>
      ),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      cell: (info) => info.getValue(),
      header: () => <span>Last Name</span>,
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
      filterFn: 'between',
    }),
    columnHelper.accessor('visits', {
      header: () => <span>Visits</span>,
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      footer: (props) => props.column.id,
    }),
  ])

  const table = createTable({
    features,
    columns,
    get data() {
      return data()
    },
    getSubRows: (row) => row.subRows, // tell the table where nested rows live
    // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
    // enableMultiRowSelection: false, // allow only one selected row at a time; default true
    // enableSubRowSelection: false, // disable sub-row selection; default true
    // enableRowRangeSelection: false, // disable shift-click range selection; default true
    // initialState: { expanded: { '0': true } }, // expand rows on first render
    // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
    // state: { expanded }, // classic controlled state; pair with onExpandedChange
    // onExpandedChange: setExpanded,
    // enableExpanding: false, // disable expanding for every row; default true
    // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
    // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
    // manualExpanding: true, // pass data that is already expanded, for example from a server
    // paginateExpandedRows: false, // keep expanded children on their parent page; default true
    // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
    // autoResetAll: false, // turn off every feature's automatic reset, including expansion
    // enableFilters: false, // disable all column and global filtering; default true
    // enableColumnFilters: false, // disable per-column filters; default true
    // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
    // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
    // manualFiltering: true, // pass data that is already filtered, for example from a server
    debugTable: true,
  })

  return (
    <div class="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (10k rows)</button>
      </div>
      <div class="spacer-sm" />
      <table>
        <thead>
          <For each={table.getHeaderGroups()}>
            {(headerGroup) => (
              <tr>
                <For each={headerGroup.headers}>
                  {(header) => (
                    <th colSpan={header.colSpan}>
                      <Show when={!header.isPlaceholder}>
                        <div>
                          <table.FlexRender header={header} />
                          <Show when={header.column.getCanFilter()}>
                            <div>
                              <Filter column={header.column} table={table} />
                            </div>
                          </Show>
                        </div>
                      </Show>
                    </th>
                  )}
                </For>
              </tr>
            )}
          </For>
        </thead>
        <tbody>
          <For each={table.getRowModel().rows}>
            {(row) => (
              <tr>
                <For each={row.getAllCells()}>
                  {(cell) => (
                    <td>
                      <table.FlexRender cell={cell} />
                    </td>
                  )}
                </For>
              </tr>
            )}
          </For>
        </tbody>
      </table>
      <div class="spacer-sm" />
      <div class="controls">
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(0)}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          class="demo-button demo-button-sm"
          onClick={() => table.setPageIndex(table.getPageCount() - 1)}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span class="inline-controls">
          <div>Page</div>
          <strong>
            {(table.atoms.pagination.get().pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span class="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.atoms.pagination.get().pageIndex + 1}
            onInput={(e) => {
              const page = e.currentTarget.value
                ? Number(e.currentTarget.value) - 1
                : 0
              table.setPageIndex(page)
            }}
            class="page-size-input"
          />
        </span>
        <select
          value={table.atoms.pagination.get().pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.currentTarget.value))
          }}
        >
          <For each={[10, 20, 30, 40, 50]}>
            {(pageSize) => <option value={pageSize}>Show {pageSize}</option>}
          </For>
        </select>
      </div>
      <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
      <pre data-testid="table-state">
        {JSON.stringify(table.store.get(), null, 2)}
      </pre>
    </div>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  const columnFilterValue = () => column.getFilterValue()

  return typeof firstValue === 'number' ? (
    <div class="filter-row">
      <input
        type="number"
        value={(columnFilterValue() as [number, number] | undefined)?.[0] ?? ''}
        onInput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            e.currentTarget.value,
            old?.[1],
          ])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={(columnFilterValue() as [number, number] | undefined)?.[1] ?? ''}
        onInput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            e.currentTarget.value,
          ])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  ) : (
    <input
      type="text"
      value={(columnFilterValue() ?? '') as string}
      onInput={(e) => column.setFilterValue(e.currentTarget.value)}
      placeholder="Search..."
      class="filter-select"
    />
  )
}

function IndeterminateCheckbox(props: {
  indeterminate?: boolean
  checked?: boolean
  className?: string
  onChange?: (event: Event) => void
  onClick?: (event: MouseEvent) => void
}) {
  let ref: HTMLInputElement | undefined

  createEffect(() => {
    if (typeof props.indeterminate === 'boolean' && ref) {
      ref.indeterminate = !props.checked && props.indeterminate
    }
  })

  return (
    <input
      type="checkbox"
      ref={ref}
      class={`${props.className ?? ''} sortable-header`}
      checked={props.checked}
      onChange={props.onChange}
      onClick={props.onClick}
    />
  )
}

export default App

Svelte Example: Expanding

<script lang="ts">
  import {
    columnFilteringFeature,
    createColumnHelper,
    createExpandedRowModel,
    createFilteredRowModel,
    createPaginatedRowModel,
    createSortedRowModel,
    createTable,
    filterFn_includesString,
    filterFn_inNumberRange,
    FlexRender,
    rowExpandingFeature,
    rowPaginationFeature,
    rowSelectionFeature,
    rowSortingFeature,
    sortFn_alphanumeric,
    sortFn_text,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import type { Column, SvelteTable } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnFilteringFeature,
    rowExpandingFeature,
    rowPaginationFeature,
    rowSortingFeature,
    rowSelectionFeature,
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel(),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(),
    filterFns: {
      includesString: filterFn_includesString,
      inNumberRange: filterFn_inNumberRange,
    },
    sortFns: {
      alphanumeric: sortFn_alphanumeric,
      text: sortFn_text,
    },
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  // Svelte action to set indeterminate property on checkbox inputs
  function setIndeterminate(node: HTMLInputElement, value: boolean) {
    node.indeterminate = value
    return {
      update(newValue: boolean) {
        node.indeterminate = newValue
      },
    }
  }

  let data = $state(makeData(100, 5, 3))
  const refreshData = () => { data = makeData(100, 5, 3) }
  const stressTest = () => { data = makeData(10_000, 5, 3) }

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'rowNumber',
      header: '#',
      cell: ({ row }) => row.getDisplayIndex() + 1,
    }),
    columnHelper.accessor('firstName', {
      header: () => 'firstName',
      cell: ({ row, getValue }) => getValue<string>(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      cell: (info) => info.getValue(),
      header: () => 'Last Name',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
      filterFn: 'inNumberRange',
    }),
    columnHelper.accessor('visits', {
      header: () => 'Visits',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      footer: (props) => props.column.id,
    }),
  ])

  const table = createTable(
    {
      features,
      columns,
      get data() {
        return data
      },
      getSubRows: (row) => row.subRows, // tell the table where nested rows live
      // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
      // enableMultiRowSelection: false, // allow only one selected row at a time; default true
      // enableSubRowSelection: false, // disable sub-row selection; default true
      // enableRowRangeSelection: false, // disable shift-click range selection; default true
      // initialState: { expanded: { '0': true } }, // expand rows on first render
      // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
      // state: { expanded }, // classic controlled state; pair with onExpandedChange
      // onExpandedChange: setExpanded,
      // enableExpanding: false, // disable expanding for every row; default true
      // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
      // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
      // manualExpanding: true, // pass data that is already expanded, for example from a server
      // paginateExpandedRows: false, // keep expanded children on their parent page; default true
      // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
      // autoResetAll: false, // turn off every feature's automatic reset, including expansion
      // enableFilters: false, // disable all column and global filtering; default true
      // enableColumnFilters: false, // disable per-column filters; default true
      // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
      // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
      // manualFiltering: true, // pass data that is already filtered, for example from a server
      debugTable: true,
    },
  )
  const pagination = $derived(table.atoms.pagination.get())
</script>

<div class="demo-root">
  <div>
    <button onclick={() => refreshData()}>Regenerate Data</button>
    <button onclick={() => stressTest()}>Stress Test (10k rows)</button>
  </div>
  <div class="spacer-sm"></div>
  <table>
    <thead>
      {#each table.getHeaderGroups() as headerGroup (headerGroup.id)
      }
        <tr>
          {#each headerGroup.headers as header (header.id)}
            <th colSpan={header.colSpan}>
              {#if !header.isPlaceholder}
                <div>
                  {#if header.id === 'firstName'}
                    <input
                      type="checkbox"
                      checked={table.getIsAllRowsSelected()}
                      use:setIndeterminate={!table.getIsAllRowsSelected() && table.getIsSomeRowsSelected()}
                      onchange={table.getToggleAllRowsSelectedHandler()}
                      class="sortable-header"
                    />
                    {' '}
                    <button onclick={table.getToggleAllRowsExpandedHandler()}>
                      {table.getIsAllRowsExpanded() ? '\u{1F447}' : '\u{1F449}'}
                    </button>
                    {' '}
                    First Name
                  {:else}
                    <FlexRender header={header} />
                  {/if}
                  {#if header.column.getCanFilter()}
                    <div>
                      {@render Filter(header.column, table)}
                    </div>
                  {/if}
                </div>
              {/if}
            </th>
          {/each}
        </tr>
      {/each}
    </thead>
    <tbody>
      {#each table.getRowModel().rows as row (row.id)}
        <tr>
          {#each row.getAllCells() as cell (cell.id)}
            <td>
              {#if cell.column.id === 'firstName'}
                <div style="padding-left: {row.depth * 2}rem">
                  <div>
                    <input
                      type="checkbox"
                      checked={row.getIsSelected() ||
                        (row.getCanSelectSubRows() &&
                          row.getIsAllSubRowsSelected())}
                      use:setIndeterminate={!row.getIsSelected() && row.getIsSomeSelected()}
                      onclick={row.getToggleSelectedHandler({
                        // selectChildren: false
                      })}
                      class="sortable-header"
                    />
                    {' '}
                    {#if row.getCanExpand()}
                      <button
                        onclick={row.getToggleExpandedHandler()}
                        style="cursor: pointer"
                      >
                        {row.getIsExpanded() ? '\u{1F447}' : '\u{1F449}'}
                      </button>
                    {:else}
                      {'\u{1F535}'}
                    {/if}
                    {' '}
                    <FlexRender cell={cell} />
                  </div>
                </div>
              {:else}
                <FlexRender cell={cell} />
              {/if}
            </td>
          {/each}
        </tr>
      {/each}
    </tbody>
  </table>
  <div class="spacer-sm"></div>
  <div class="controls">
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(0)
      }
      disabled={!table.getCanPreviousPage()}
    >
      {'<<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.previousPage()}
      disabled={!table.getCanPreviousPage()}
    >
      {'<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.nextPage()}
      disabled={!table.getCanNextPage()}
    >
      {'>'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(table.getPageCount() - 1)}
      disabled={!table.getCanNextPage()}
    >
      {'>>'}
    </button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={pagination.pageIndex + 1}
        oninput={(e) => {
          const page = (e.target as HTMLInputElement).value
            ? Number((e.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={pagination.pageSize}
      onchange={(e) => {
        table.setPageSize(Number((e.target as HTMLSelectElement).value))
      }}
    >
      {#each [10, 20, 30, 40, 50] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
  <pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>

{#snippet Filter(column: Column<typeof features, Person>, table: SvelteTable<typeof features, Person>)}
  {@const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)}

  {#if typeof firstValue === 'number'}
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as [number, number] | undefined)?.[0] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            (e.target as HTMLInputElement).value,
            old?.[1],
          ])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as [number, number] | undefined)?.[1] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            (e.target as HTMLInputElement).value,
          ])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  {:else}
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      oninput={(e) => column.setFilterValue((e.target as HTMLInputElement).value)}
      placeholder="Search..."
      class="filter-select"
    />
  {/if}
{/snippet}
<script lang="ts">
  import {
    columnFilteringFeature,
    createColumnHelper,
    createExpandedRowModel,
    createFilteredRowModel,
    createPaginatedRowModel,
    createSortedRowModel,
    createTable,
    filterFn_includesString,
    filterFn_inNumberRange,
    FlexRender,
    rowExpandingFeature,
    rowPaginationFeature,
    rowSelectionFeature,
    rowSortingFeature,
    sortFn_alphanumeric,
    sortFn_text,
    tableFeatures,
  } from '@tanstack/svelte-table'
  import type { Column, SvelteTable } from '@tanstack/svelte-table'
  import { makeData } from './makeData'
  import type { Person } from './makeData'
  import './index.css'

  const features = tableFeatures({
    columnFilteringFeature,
    rowExpandingFeature,
    rowPaginationFeature,
    rowSortingFeature,
    rowSelectionFeature,
    expandedRowModel: createExpandedRowModel(),
    filteredRowModel: createFilteredRowModel(),
    paginatedRowModel: createPaginatedRowModel(),
    sortedRowModel: createSortedRowModel(),
    filterFns: {
      includesString: filterFn_includesString,
      inNumberRange: filterFn_inNumberRange,
    },
    sortFns: {
      alphanumeric: sortFn_alphanumeric,
      text: sortFn_text,
    },
  })

  const columnHelper = createColumnHelper<typeof features, Person>()

  // Svelte action to set indeterminate property on checkbox inputs
  function setIndeterminate(node: HTMLInputElement, value: boolean) {
    node.indeterminate = value
    return {
      update(newValue: boolean) {
        node.indeterminate = newValue
      },
    }
  }

  let data = $state(makeData(100, 5, 3))
  const refreshData = () => { data = makeData(100, 5, 3) }
  const stressTest = () => { data = makeData(10_000, 5, 3) }

  const columns = columnHelper.columns([
    columnHelper.display({
      id: 'rowNumber',
      header: '#',
      cell: ({ row }) => row.getDisplayIndex() + 1,
    }),
    columnHelper.accessor('firstName', {
      header: () => 'firstName',
      cell: ({ row, getValue }) => getValue<string>(),
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor((row) => row.lastName, {
      id: 'lastName',
      cell: (info) => info.getValue(),
      header: () => 'Last Name',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('age', {
      header: () => 'Age',
      footer: (props) => props.column.id,
      filterFn: 'inNumberRange',
    }),
    columnHelper.accessor('visits', {
      header: () => 'Visits',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('status', {
      header: 'Status',
      footer: (props) => props.column.id,
    }),
    columnHelper.accessor('progress', {
      header: 'Profile Progress',
      footer: (props) => props.column.id,
    }),
  ])

  const table = createTable(
    {
      features,
      columns,
      get data() {
        return data
      },
      getSubRows: (row) => row.subRows, // tell the table where nested rows live
      // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
      // enableMultiRowSelection: false, // allow only one selected row at a time; default true
      // enableSubRowSelection: false, // disable sub-row selection; default true
      // enableRowRangeSelection: false, // disable shift-click range selection; default true
      // initialState: { expanded: { '0': true } }, // expand rows on first render
      // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
      // state: { expanded }, // classic controlled state; pair with onExpandedChange
      // onExpandedChange: setExpanded,
      // enableExpanding: false, // disable expanding for every row; default true
      // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
      // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
      // manualExpanding: true, // pass data that is already expanded, for example from a server
      // paginateExpandedRows: false, // keep expanded children on their parent page; default true
      // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
      // autoResetAll: false, // turn off every feature's automatic reset, including expansion
      // enableFilters: false, // disable all column and global filtering; default true
      // enableColumnFilters: false, // disable per-column filters; default true
      // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
      // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
      // manualFiltering: true, // pass data that is already filtered, for example from a server
      debugTable: true,
    },
  )
  const pagination = $derived(table.atoms.pagination.get())
</script>

<div class="demo-root">
  <div>
    <button onclick={() => refreshData()}>Regenerate Data</button>
    <button onclick={() => stressTest()}>Stress Test (10k rows)</button>
  </div>
  <div class="spacer-sm"></div>
  <table>
    <thead>
      {#each table.getHeaderGroups() as headerGroup (headerGroup.id)
      }
        <tr>
          {#each headerGroup.headers as header (header.id)}
            <th colSpan={header.colSpan}>
              {#if !header.isPlaceholder}
                <div>
                  {#if header.id === 'firstName'}
                    <input
                      type="checkbox"
                      checked={table.getIsAllRowsSelected()}
                      use:setIndeterminate={!table.getIsAllRowsSelected() && table.getIsSomeRowsSelected()}
                      onchange={table.getToggleAllRowsSelectedHandler()}
                      class="sortable-header"
                    />
                    {' '}
                    <button onclick={table.getToggleAllRowsExpandedHandler()}>
                      {table.getIsAllRowsExpanded() ? '\u{1F447}' : '\u{1F449}'}
                    </button>
                    {' '}
                    First Name
                  {:else}
                    <FlexRender header={header} />
                  {/if}
                  {#if header.column.getCanFilter()}
                    <div>
                      {@render Filter(header.column, table)}
                    </div>
                  {/if}
                </div>
              {/if}
            </th>
          {/each}
        </tr>
      {/each}
    </thead>
    <tbody>
      {#each table.getRowModel().rows as row (row.id)}
        <tr>
          {#each row.getAllCells() as cell (cell.id)}
            <td>
              {#if cell.column.id === 'firstName'}
                <div style="padding-left: {row.depth * 2}rem">
                  <div>
                    <input
                      type="checkbox"
                      checked={row.getIsSelected() ||
                        (row.getCanSelectSubRows() &&
                          row.getIsAllSubRowsSelected())}
                      use:setIndeterminate={!row.getIsSelected() && row.getIsSomeSelected()}
                      onclick={row.getToggleSelectedHandler({
                        // selectChildren: false
                      })}
                      class="sortable-header"
                    />
                    {' '}
                    {#if row.getCanExpand()}
                      <button
                        onclick={row.getToggleExpandedHandler()}
                        style="cursor: pointer"
                      >
                        {row.getIsExpanded() ? '\u{1F447}' : '\u{1F449}'}
                      </button>
                    {:else}
                      {'\u{1F535}'}
                    {/if}
                    {' '}
                    <FlexRender cell={cell} />
                  </div>
                </div>
              {:else}
                <FlexRender cell={cell} />
              {/if}
            </td>
          {/each}
        </tr>
      {/each}
    </tbody>
  </table>
  <div class="spacer-sm"></div>
  <div class="controls">
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(0)
      }
      disabled={!table.getCanPreviousPage()}
    >
      {'<<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.previousPage()}
      disabled={!table.getCanPreviousPage()}
    >
      {'<'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.nextPage()}
      disabled={!table.getCanNextPage()}
    >
      {'>'}
    </button>
    <button
      class="demo-button demo-button-sm"
      onclick={() => table.setPageIndex(table.getPageCount() - 1)}
      disabled={!table.getCanNextPage()}
    >
      {'>>'}
    </button>
    <span class="inline-controls">
      <div>Page</div>
      <strong>
        {(pagination.pageIndex + 1).toLocaleString()} of{' '}
        {table.getPageCount().toLocaleString()}
      </strong>
    </span>
    <span class="inline-controls">
      | Go to page:
      <input
        type="number"
        min="1"
        max={table.getPageCount()}
        value={pagination.pageIndex + 1}
        oninput={(e) => {
          const page = (e.target as HTMLInputElement).value
            ? Number((e.target as HTMLInputElement).value) - 1
            : 0
          table.setPageIndex(page)
        }}
        class="page-size-input"
      />
    </span>
    <select
      value={pagination.pageSize}
      onchange={(e) => {
        table.setPageSize(Number((e.target as HTMLSelectElement).value))
      }}
    >
      {#each [10, 20, 30, 40, 50] as pageSize}
        <option value={pageSize}>Show {pageSize}</option>
      {/each}
    </select>
  </div>
  <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
  <pre data-testid="table-state">{JSON.stringify(table.store.get(), null, 2)}</pre>
</div>

{#snippet Filter(column: Column<typeof features, Person>, table: SvelteTable<typeof features, Person>)}
  {@const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)}

  {#if typeof firstValue === 'number'}
    <div class="filter-row">
      <input
        type="number"
        value={((column.getFilterValue() as [number, number] | undefined)?.[0] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            (e.target as HTMLInputElement).value,
            old?.[1],
          ])
        }
        placeholder="Min"
        class="filter-input"
      />
      <input
        type="number"
        value={((column.getFilterValue() as [number, number] | undefined)?.[1] ?? '') as string}
        oninput={(e) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            (e.target as HTMLInputElement).value,
          ])
        }
        placeholder="Max"
        class="filter-input"
      />
    </div>
  {:else}
    <input
      type="text"
      value={(column.getFilterValue() ?? '') as string}
      oninput={(e) => column.setFilterValue((e.target as HTMLInputElement).value)}
      placeholder="Search..."
      class="filter-select"
    />
  {/if}
{/snippet}

React Example: Expanding

import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnFilteringFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFn_between,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import { makeData } from './makeData'
import type { HTMLProps } from 'react'
import type { Person } from './makeData'
import type { Column, Table } from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  columnFilteringFeature,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSortingFeature,
  rowSelectionFeature,
  expandedRowModel: createExpandedRowModel(),
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  sortedRowModel: createSortedRowModel(),
  filterFns: {
    between: filterFn_between,
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

function App() {
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'rowNumber',
          header: '#',
          cell: ({ row }) => row.getDisplayIndex() + 1,
        }),
        columnHelper.accessor('firstName', {
          header: ({ table }) => (
            <>
              <IndeterminateCheckbox
                checked={table.getIsAllRowsSelected()}
                indeterminate={table.getIsSomeRowsSelected()}
                onChange={table.getToggleAllRowsSelectedHandler()}
              />{' '}
              <button onClick={table.getToggleAllRowsExpandedHandler()}>
                {table.getIsAllRowsExpanded() ? '👇' : '👉'}
              </button>{' '}
              First Name
            </>
          ),
          cell: ({ row, getValue }) => (
            <div
              style={{
                // Since rows are flattened by default,
                // we can use the row.depth property
                // and paddingLeft to visually indicate the depth
                // of the row
                paddingLeft: `${row.depth * 2}rem`,
              }}
            >
              <div>
                <IndeterminateCheckbox
                  checked={
                    row.getIsSelected() ||
                    (row.getCanSelectSubRows() && row.getIsAllSubRowsSelected())
                  }
                  indeterminate={row.getIsSomeSelected()}
                  onChange={row.getToggleSelectedHandler({
                    // selectChildren: false
                  })}
                />{' '}
                {row.getCanExpand() ? (
                  <button
                    onClick={row.getToggleExpandedHandler()}
                    style={{ cursor: 'pointer' }}
                  >
                    {row.getIsExpanded() ? '👇' : '👉'}
                  </button>
                ) : (
                  '🔵'
                )}{' '}
                {getValue<boolean>()}
              </div>
            </div>
          ),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => <span>Last Name</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
          filterFn: 'between',
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          footer: (props) => props.column.id,
        }),
      ]),
    [],
  )

  const [data, setData] = React.useState(() => makeData(100, 5, 3))
  const refreshData = () => setData(makeData(100, 5, 3))
  const stressTest = () => setData(makeData(10_000, 5, 3))

  const table = useTable(
    {
      features,
      columns,
      data,
      getSubRows: (row) => row.subRows, // tell the table where nested rows live
      // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
      // enableMultiRowSelection: false, // allow only one selected row at a time; default true
      // enableSubRowSelection: false, // disable sub-row selection; default true
      // enableRowRangeSelection: false, // disable shift-click range selection; default true
      // initialState: { expanded: { '0': true } }, // expand rows on first render
      // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
      // state: { expanded }, // classic controlled state; pair with onExpandedChange
      // onExpandedChange: setExpanded,
      // enableExpanding: false, // disable expanding for every row; default true
      // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
      // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
      // manualExpanding: true, // pass data that is already expanded, for example from a server
      // paginateExpandedRows: false, // keep expanded children on their parent page; default true
      // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
      // autoResetAll: false, // turn off every feature's automatic reset, including expansion
      // enableFilters: false, // disable all column and global filtering; default true
      // enableColumnFilters: false, // disable per-column filters; default true
      // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
      // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
      // manualFiltering: true, // pass data that is already filtered, for example from a server
      debugTable: true,
      debugRows: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (10k rows)</button>
      </div>
      <div className="spacer-sm" />
      <table>
        <thead>
          {table.getHeaderGroups().map((headerGroup) => (
            <tr key={headerGroup.id}>
              {headerGroup.headers.map((header) => {
                return (
                  <th key={header.id} colSpan={header.colSpan}>
                    {header.isPlaceholder ? null : (
                      <div>
                        <table.FlexRender header={header} />
                        {header.column.getCanFilter() ? (
                          <div>
                            <Filter column={header.column} table={table} />
                          </div>
                        ) : null}
                      </div>
                    )}
                  </th>
                )
              })}
            </tr>
          ))}
        </thead>
        <tbody>
          {table.getRowModel().rows.map((row) => {
            return (
              <tr key={row.id}>
                {row.getAllCells().map((cell) => {
                  return (
                    <td key={cell.id}>
                      <table.FlexRender cell={cell} />
                    </td>
                  )
                })}
              </tr>
            )
          })}
        </tbody>
      </table>
      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(e) => {
              const page = e.target.value ? Number(e.target.value) - 1 : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.target.value))
          }}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
      <div></div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  const columnFilterValue = column.getFilterValue()

  return typeof firstValue === 'number' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        value={(columnFilterValue as [number, number] | undefined)?.[0] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            value,
            old?.[1],
          ])
        }
        placeholder={`Min`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        value={(columnFilterValue as [number, number] | undefined)?.[1] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            value,
          ])
        }
        placeholder={`Max`}
        className="filter-input"
      />
    </div>
  ) : (
    <DebouncedInput
      type="text"
      value={(columnFilterValue ?? '') as string}
      onChange={(value) => column.setFilterValue(value)}
      placeholder={`Search...`}
      className="filter-select"
    />
  )
}

// A debounced input react component
function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 500,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

function IndeterminateCheckbox({
  indeterminate,
  className = '',
  ...rest
}: { indeterminate?: boolean } & HTMLProps<HTMLInputElement>) {
  const ref = React.useRef<HTMLInputElement>(null!)

  React.useEffect(() => {
    if (typeof indeterminate === 'boolean') {
      ref.current.indeterminate = !rest.checked && indeterminate
    }
  }, [ref, indeterminate, rest.checked])

  return (
    <input
      type="checkbox"
      ref={ref}
      className={className + ' sortable-header'}
      {...rest}
    />
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)
import React from 'react'
import ReactDOM from 'react-dom/client'
import {
  columnFilteringFeature,
  createColumnHelper,
  createExpandedRowModel,
  createFilteredRowModel,
  createPaginatedRowModel,
  createSortedRowModel,
  filterFn_between,
  filterFn_inNumberRange,
  filterFn_includesString,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSelectionFeature,
  rowSortingFeature,
  sortFn_alphanumeric,
  sortFn_text,
  tableFeatures,
  useTable,
} from '@tanstack/react-table'
import { useDebouncedCallback } from '@tanstack/react-pacer/debouncer'
import { makeData } from './makeData'
import type { HTMLProps } from 'react'
import type { Person } from './makeData'
import type { Column, Table } from '@tanstack/react-table'
import './index.css'

const features = tableFeatures({
  columnFilteringFeature,
  rowExpandingFeature,
  rowPaginationFeature,
  rowSortingFeature,
  rowSelectionFeature,
  expandedRowModel: createExpandedRowModel(),
  filteredRowModel: createFilteredRowModel(),
  paginatedRowModel: createPaginatedRowModel(),
  sortedRowModel: createSortedRowModel(),
  filterFns: {
    between: filterFn_between,
    includesString: filterFn_includesString,
    inNumberRange: filterFn_inNumberRange,
  },
  sortFns: {
    alphanumeric: sortFn_alphanumeric,
    text: sortFn_text,
  },
})

const columnHelper = createColumnHelper<typeof features, Person>()

function App() {
  const columns = React.useMemo(
    () =>
      columnHelper.columns([
        columnHelper.display({
          id: 'rowNumber',
          header: '#',
          cell: ({ row }) => row.getDisplayIndex() + 1,
        }),
        columnHelper.accessor('firstName', {
          header: ({ table }) => (
            <>
              <IndeterminateCheckbox
                checked={table.getIsAllRowsSelected()}
                indeterminate={table.getIsSomeRowsSelected()}
                onChange={table.getToggleAllRowsSelectedHandler()}
              />{' '}
              <button onClick={table.getToggleAllRowsExpandedHandler()}>
                {table.getIsAllRowsExpanded() ? '👇' : '👉'}
              </button>{' '}
              First Name
            </>
          ),
          cell: ({ row, getValue }) => (
            <div
              style={{
                // Since rows are flattened by default,
                // we can use the row.depth property
                // and paddingLeft to visually indicate the depth
                // of the row
                paddingLeft: `${row.depth * 2}rem`,
              }}
            >
              <div>
                <IndeterminateCheckbox
                  checked={
                    row.getIsSelected() ||
                    (row.getCanSelectSubRows() && row.getIsAllSubRowsSelected())
                  }
                  indeterminate={row.getIsSomeSelected()}
                  onChange={row.getToggleSelectedHandler({
                    // selectChildren: false
                  })}
                />{' '}
                {row.getCanExpand() ? (
                  <button
                    onClick={row.getToggleExpandedHandler()}
                    style={{ cursor: 'pointer' }}
                  >
                    {row.getIsExpanded() ? '👇' : '👉'}
                  </button>
                ) : (
                  '🔵'
                )}{' '}
                {getValue<boolean>()}
              </div>
            </div>
          ),
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor((row) => row.lastName, {
          id: 'lastName',
          cell: (info) => info.getValue(),
          header: () => <span>Last Name</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('age', {
          header: () => 'Age',
          footer: (props) => props.column.id,
          filterFn: 'between',
        }),
        columnHelper.accessor('visits', {
          header: () => <span>Visits</span>,
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('status', {
          header: 'Status',
          footer: (props) => props.column.id,
        }),
        columnHelper.accessor('progress', {
          header: 'Profile Progress',
          footer: (props) => props.column.id,
        }),
      ]),
    [],
  )

  const [data, setData] = React.useState(() => makeData(100, 5, 3))
  const refreshData = () => setData(makeData(100, 5, 3))
  const stressTest = () => setData(makeData(10_000, 5, 3))

  const table = useTable(
    {
      features,
      columns,
      data,
      getSubRows: (row) => row.subRows, // tell the table where nested rows live
      // enableRowSelection: row => row.original.age > 18, // enable selection conditionally; default true
      // enableMultiRowSelection: false, // allow only one selected row at a time; default true
      // enableSubRowSelection: false, // disable sub-row selection; default true
      // enableRowRangeSelection: false, // disable shift-click range selection; default true
      // initialState: { expanded: { '0': true } }, // expand rows on first render
      // atoms: { expanded: expandedAtom }, // preferred: own expanded state with an external atom
      // state: { expanded }, // classic controlled state; pair with onExpandedChange
      // onExpandedChange: setExpanded,
      // enableExpanding: false, // disable expanding for every row; default true
      // getRowCanExpand: row => row.original.subRows?.length > 0, // override which rows can expand
      // getIsRowExpanded: row => row.id === '0', // override whether a row is expanded
      // manualExpanding: true, // pass data that is already expanded, for example from a server
      // paginateExpandedRows: false, // keep expanded children on their parent page; default true
      // autoResetExpanded: false, // keep expanded rows after page-altering changes; default true
      // autoResetAll: false, // turn off every feature's automatic reset, including expansion
      // enableFilters: false, // disable all column and global filtering; default true
      // enableColumnFilters: false, // disable per-column filters; default true
      // filterFromLeafRows: true, // with filtering, keep parents whose descendants match
      // maxLeafRowFilterDepth: 0, // with filtering, only filter root rows
      // manualFiltering: true, // pass data that is already filtered, for example from a server
      debugTable: true,
      debugRows: true,
    },
    (state) => state, // default selector
  )

  return (
    <div className="demo-root">
      <div>
        <button onClick={() => refreshData()}>Regenerate Data</button>
        <button onClick={() => stressTest()}>Stress Test (10k rows)</button>
      </div>
      <div className="spacer-sm" />
      <table>
        <thead>
          {table.getHeaderGroups().map((headerGroup) => (
            <tr key={headerGroup.id}>
              {headerGroup.headers.map((header) => {
                return (
                  <th key={header.id} colSpan={header.colSpan}>
                    {header.isPlaceholder ? null : (
                      <div>
                        <table.FlexRender header={header} />
                        {header.column.getCanFilter() ? (
                          <div>
                            <Filter column={header.column} table={table} />
                          </div>
                        ) : null}
                      </div>
                    )}
                  </th>
                )
              })}
            </tr>
          ))}
        </thead>
        <tbody>
          {table.getRowModel().rows.map((row) => {
            return (
              <tr key={row.id}>
                {row.getAllCells().map((cell) => {
                  return (
                    <td key={cell.id}>
                      <table.FlexRender cell={cell} />
                    </td>
                  )
                })}
              </tr>
            )
          })}
        </tbody>
      </table>
      <div className="spacer-sm" />
      <div className="controls">
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.firstPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.previousPage()}
          disabled={!table.getCanPreviousPage()}
        >
          {'<'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.nextPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>'}
        </button>
        <button
          className="demo-button demo-button-sm"
          onClick={() => table.lastPage()}
          disabled={!table.getCanNextPage()}
        >
          {'>>'}
        </button>
        <span className="inline-controls">
          <div>Page</div>
          <strong>
            {(table.state.pagination.pageIndex + 1).toLocaleString()} of{' '}
            {table.getPageCount().toLocaleString()}
          </strong>
        </span>
        <span className="inline-controls">
          | Go to page:
          <input
            type="number"
            min="1"
            max={table.getPageCount()}
            value={table.state.pagination.pageIndex + 1}
            onChange={(e) => {
              const page = e.target.value ? Number(e.target.value) - 1 : 0
              table.setPageIndex(page)
            }}
            className="page-size-input"
          />
        </span>
        <select
          value={table.state.pagination.pageSize}
          onChange={(e) => {
            table.setPageSize(Number(e.target.value))
          }}
        >
          {[10, 20, 30, 40, 50].map((pageSize) => (
            <option key={pageSize} value={pageSize}>
              Show {pageSize}
            </option>
          ))}
        </select>
      </div>
      <div>{table.getRowModel().rows.length.toLocaleString()} Rows</div>
      <div></div>
      <pre data-testid="table-state">
        {JSON.stringify(table.state, null, 2)}
      </pre>
    </div>
  )
}

function Filter({
  column,
  table,
}: {
  column: Column<typeof features, Person>
  table: Table<typeof features, Person>
}) {
  const firstValue = table
    .getPreFilteredRowModel()
    .flatRows[0]?.getValue(column.id)

  const columnFilterValue = column.getFilterValue()

  return typeof firstValue === 'number' ? (
    <div className="filter-row">
      <DebouncedInput
        type="number"
        value={(columnFilterValue as [number, number] | undefined)?.[0] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            value,
            old?.[1],
          ])
        }
        placeholder={`Min`}
        className="filter-input"
      />
      <DebouncedInput
        type="number"
        value={(columnFilterValue as [number, number] | undefined)?.[1] ?? ''}
        onChange={(value) =>
          column.setFilterValue((old: [number, number] | undefined) => [
            old?.[0],
            value,
          ])
        }
        placeholder={`Max`}
        className="filter-input"
      />
    </div>
  ) : (
    <DebouncedInput
      type="text"
      value={(columnFilterValue ?? '') as string}
      onChange={(value) => column.setFilterValue(value)}
      placeholder={`Search...`}
      className="filter-select"
    />
  )
}

// A debounced input react component
function DebouncedInput({
  value: initialValue,
  onChange,
  debounce = 500,
  ...props
}: {
  value: string | number
  onChange: (value: string | number) => void
  debounce?: number
} & Omit<React.InputHTMLAttributes<HTMLInputElement>, 'onChange'>) {
  const [value, setValue] = React.useState(initialValue)

  React.useEffect(() => {
    setValue(initialValue)
  }, [initialValue])

  const debouncedOnChange = useDebouncedCallback(onChange, { wait: debounce })

  return (
    <input
      {...props}
      value={value}
      onChange={(e) => {
        setValue(e.target.value)
        debouncedOnChange(e.target.value)
      }}
    />
  )
}

function IndeterminateCheckbox({
  indeterminate,
  className = '',
  ...rest
}: { indeterminate?: boolean } & HTMLProps<HTMLInputElement>) {
  const ref = React.useRef<HTMLInputElement>(null!)

  React.useEffect(() => {
    if (typeof indeterminate === 'boolean') {
      ref.current.indeterminate = !rest.checked && indeterminate
    }
  }, [ref, indeterminate, rest.checked])

  return (
    <input
      type="checkbox"
      ref={ref}
      className={className + ' sortable-header'}
      {...rest}
    />
  )
}

const rootElement = document.getElementById('root')
if (!rootElement) throw new Error('Failed to find the root element')

ReactDOM.createRoot(rootElement).render(
  <React.StrictMode>
    <App />
  </React.StrictMode>,
)

TanStack
Table betabeta
Libraries
Framework
StartRC
Docs
Router
Docs
Data & State Management
Query
Docs
DBbeta
Docs
Storealpha
Docs
AIbeta
Docs
UI & UX
Table
Docs
Formnew
Docs
Hotkeysalpha
Docs
Performance
Virtual
Docs
Pacerbeta
Docs
Tooling
Devtoolsalpha
Docs
Config
Docs
CLIalpha
Docs
Intentalpha
Docs
Resources
BlogRelease notes, architecture notes, and essays.YouTubeThe official TanStack channel.
Workshops
Learn from maintainers

Remote and in-person TanStack workshops for teams that need depth.

Professional Workshops
Channels
DiscordCommunity support and real-time discussion.GitHubSource, issues, discussions, and releases.
People & Work
MaintainersMeet the people maintaining the stack.ContributorsCore, library, and community contributors.ShowcaseProducts and teams building with TanStack.
Tools
BuilderAlphaGenerate TanStack app starters.StatsNPM and ecosystem usage data.
Merch
Recent Products
All MerchBrowse all TanStack apparel, accessories, and stickers.
Support
Support OverviewFind the right support path.PartnersCompanies supporting TanStack.OSS SponsorsSponsors keeping TanStack open source.Enterprise SupportPrivate consulting and expert support.ContactGet in touch with the TanStack team.
About
EthosHow we think about open source and products.TenetsThe values that shape TanStack libraries.Brand GuideLogos, colors, and brand usage.
Partners
Work with TanStack

Sponsorships, placements, and partner pages.

Partnership Inquiry
Log In
Log In
All LibrariesBrowse the full set of public packages.
Framework
StartRC
Docs
Router
Docs
Data & State Management
Query
Docs
DBbeta
Docs
Storealpha
Docs
AIbeta
Docs
UI & UX
Table
Docs
Formnew
Docs
Hotkeysalpha
Docs
Performance
Virtual
Docs
Pacerbeta
Docs
Tooling
Devtoolsalpha
Docs
Config
Docs
CLIalpha
Docs
Intentalpha
Docs
Resources
BlogRelease notes, architecture notes, and essays.YouTubeThe official TanStack channel.
Professional Workshops
Channels
DiscordCommunity support and real-time discussion.GitHubSource, issues, discussions, and releases.
People & Work
MaintainersMeet the people maintaining the stack.ContributorsCore, library, and community contributors.ShowcaseProducts and teams building with TanStack.
Tools
BuilderAlphaGenerate TanStack app starters.StatsNPM and ecosystem usage data.
Recent Products
All MerchBrowse all TanStack apparel, accessories, and stickers.
Support
Support OverviewFind the right support path.PartnersCompanies supporting TanStack.OSS SponsorsSponsors keeping TanStack open source.Enterprise SupportPrivate consulting and expert support.ContactGet in touch with the TanStack team.
About
EthosHow we think about open source and products.TenetsThe values that shape TanStack libraries.Brand GuideLogos, colors, and brand usage.
Partnership Inquiry
Docs
Basic Examples
  • Basic (useTable)
  • Basic (useAppTable)
  • Basic (External State)
  • Basic (External Atoms)
  • Basic (Dynamic Columns)
  • Header Groups
Feature Examples
  • Kitchen Sink (All Features)
  • Cell Selection
  • Cell Spanning
  • Column Filters
  • Column Filters (Faceted)
  • Bucketed Faceted Filters
  • Fuzzy Search Filters
  • Column Ordering
  • Column Pinning
  • Column Pinning (Split)
  • Sticky Column Pinning
  • Column Sizing
  • Column Resizing
  • Performant Column Resizing
  • Column Visibility
  • Expanding
  • Expanding Sub Components
  • Grouping
  • Aggregation
  • Grouped Aggregation
  • Pagination
  • Row Pinning
  • Row Selection
  • Sorting
Specialized Examples
  • Composable Tables (createTableHook)
  • With TanStack Virtual - Columns
  • With TanStack Virtual - Rows
  • With TanStack Virtual - Infinite Scrolling
  • With TanStack Form
  • With TanStack Query
HomeGet StartedGuidesAPIExamples
Basic Examples
  • Basic (useTable)
  • Basic (useAppTable)
  • Basic (External State)
  • Basic (External Atoms)
  • Basic (Dynamic Columns)
  • Header Groups
Feature Examples
  • Kitchen Sink (All Features)
  • Cell Selection
  • Cell Spanning
  • Column Filters
  • Column Filters (Faceted)
  • Bucketed Faceted Filters
  • Fuzzy Search Filters
  • Column Ordering
  • Column Pinning
  • Column Pinning (Split)
  • Sticky Column Pinning
  • Column Sizing
  • Column Resizing
  • Performant Column Resizing
  • Column Visibility
  • Expanding
  • Expanding Sub Components
  • Grouping
  • Aggregation
  • Grouped Aggregation
  • Pagination
  • Row Pinning
  • Row Selection
  • Sorting
Specialized Examples
  • Composable Tables (createTableHook)
  • With TanStack Virtual - Columns
  • With TanStack Virtual - Rows
  • With TanStack Virtual - Infinite Scrolling
  • With TanStack Form
  • With TanStack Query

Vue Example: Expanding
GitHub StackBlitz CodeSandbox

<script setup lang="ts">
import AppImpl from './App.tsx'
</script>

<template>
  <AppImpl />
</template>
<script setup lang="ts">
import AppImpl from './App.tsx'
</script>

<template>
  <AppImpl />
</template>
Blog
@Tan_Stack on X.com
@TannerLinsley on X.com
GitHub
YouTube
Nozzle.io - Keyword Rank Tracker
Ethos
Tenets
Privacy Policy
Terms of Service
© 2026 TanStack LLC
PartnersBecome a Partner
Gold
CloudflareCloudflare
CodeRabbitCodeRabbit
RailwayRailway
Silver
WorkOSWorkOS
AG GridAG Grid
OpenRouterOpenRouter
ClerkClerk
NetlifyNetlify
SerpAPISerpAPI
Bronze
ElectricElectric
UnkeyUnkey
SentrySentry
PrismaPrisma
    Latest Posts
    TanStack Start and TanStack AI Win 2026 Open Source AwardsJun 22, 2026How an Underrated Refactor Saved 90% Memory UsageJun 22, 2026TypeScript Performance in TanStack Table V9Jun 14, 2026

TanStack

Angular Example: Expanding

import {
  ChangeDetectionStrategy,
  Component,
  computed,
  signal,
} from '@angular/core'
import {
  ColumnDef,
  createAngularTable,
  ExpandedState,
  flexRenderComponent,
  FlexRenderDirective,
  getCoreRowModel,
  getExpandedRowModel,
  getFilteredRowModel,
  getPaginationRowModel,
} from '@tanstack/angular-table'
import { makeData, type Person } from './makeData'
import { ReactiveFormsModule } from '@angular/forms'
import { ExpandableCell, ExpandableHeaderCell } from './expandable-cell'

const defaultColumns: ColumnDef<Person>[] = [
  {
    accessorKey: 'firstName',
    header: () =>
      flexRenderComponent(ExpandableHeaderCell, {
        inputs: {
          label: 'First name',
        },
      }),
    cell: () => flexRenderComponent(ExpandableCell),
  },
  {
    accessorFn: (row) => row.lastName,
    id: 'lastName',
    cell: (info) => info.getValue(),
    header: () => 'Last Name',
    footer: (props) => props.column.id,
  },
  {
    accessorKey: 'age',
    header: () => 'Age',
    footer: (props) => props.column.id,
  },
  {
    accessorKey: 'visits',
    header: () => `Visits`,
    footer: (props) => props.column.id,
  },
  {
    accessorKey: 'status',
    header: 'Status',
    footer: (props) => props.column.id,
  },
  {
    accessorKey: 'progress',
    header: 'Profile Progress',
    footer: (props) => props.column.id,
  },
]

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [FlexRenderDirective, ReactiveFormsModule],
  templateUrl: './app.component.html',
  changeDetection: ChangeDetectionStrategy.OnPush,
})
export class AppComponent {
  readonly data = signal<Person[]>(makeData(100, 5, 3))
  readonly expanded = signal<ExpandedState>({})

  readonly table = createAngularTable(() => ({
    data: this.data(),
    columns: defaultColumns,
    state: {
      expanded: this.expanded(),
    },
    onExpandedChange: (updater) =>
      typeof updater === 'function'
        ? this.expanded.update(updater)
        : this.expanded.set(updater),
    getSubRows: (row) => row.subRows,
    getCoreRowModel: getCoreRowModel(),
    getPaginationRowModel: getPaginationRowModel(),
    getFilteredRowModel: getFilteredRowModel(),
    getExpandedRowModel: getExpandedRowModel(),
    // filterFromLeafRows: true,
    // maxLeafRowFilterDepth: 0,
    debugTable: true,
  }))

  readonly rawExpandedState = computed(() =>
    JSON.stringify(this.expanded(), undefined, 2),
  )

  readonly rawRowSelectionState = computed(() =>
    JSON.stringify(this.table.getState().rowSelection, undefined, 2),
  )

  onPageInputChange(event: Event): void {
    const inputElement = event.target as HTMLInputElement
    const page = inputElement.value ? Number(inputElement.value) - 1 : 0
    this.table.setPageIndex(page)
  }

  onPageSizeChange(event: any): void {
    this.table.setPageSize(Number(event.target.value))
  }
}